<!-- HTML header for doxygen 1.8.18-->
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
  <head>
    <meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8" />
    <meta http-equiv="X-UA-Compatible" content="IE=9" />
    <meta name="generator" content="Doxygen 1.9.1" />
    <meta name="viewport" content="width=device-width, initial-scale=1" />
    <title>VizBlocks: Behaviour Class Reference</title>
    <link href="tabs.css" rel="stylesheet" type="text/css" />
    <script type="text/javascript" src="jquery.js"></script>
    <script type="text/javascript" src="dynsections.js"></script>
     <link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
    <link href="my_customdoxygen.css" rel="stylesheet" type="text/css" />
  </head>
  <body>
    <div id="top">
      <!-- do not remove this div, it is closed by doxygen! -->
      <header id="header" class="desktop">
        <div>
          <div class="inner-header">
            <div class="logotype">
              <a href="https://edinburgh-college-of-art.github.io/vizblocks-website/" aria-hidden="true" title="Site home"
                >VizBlocks</a
              >
            </div>
            <div class="navigation">
              <button
                onclick="toggleBurger()"
                type="button"
                aria-label="toggle burger menu"
              >
                <i class="fa fa-bars"></i>
              </button>
              <nav id="menu" class="collapse">
                <a href="https://edinburgh-college-of-art.github.io/vizblocks-website/" class="home">Home</a>
                <a href="https://edinburgh-college-of-art.github.io/vizblocks-website/about" class="about">About</a>
                <a
                  href="https://edinburgh-college-of-art.github.io/vizblocks-website/tutorials/0_getting_started.html"
                  class="start"
                  >Get Started</a
                >
                <a href="https://edinburgh-college-of-art.github.io/vizblocks-website/tutorials" class="tutorials"
                  >Tutorials</a
                >
                <a href="https://edinburgh-college-of-art.github.io/vizblocks-website/docs/html" class="docs"
                  >Technical Info</a
                >
                <a href="https://edinburgh-college-of-art.github.io/vizblocks-website/contact" class="content">Contact</a>
              </nav>
            </div>
          </div>
        </div>
        <script>
          const toggleBurger = () => {
            const menu = document.getElementById("menu");
            if (menu.className === "collapse") {
              menu.className = "extend";
            } else {
              menu.className = "collapse";
            }
          };
          const touchDevice = "ontouchstart" in document.documentElement;
          if (touchDevice) {
            const header = document.getElementById("header");
            header.className = "mobile";
          }
        </script>
      </header>
      <!-- end header part -->
    </div>
  </body>
</html>
<!-- Generated by Doxygen 1.9.1 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search','.html');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pro-attribs">Protected Attributes</a> &#124;
<a href="class_behaviour-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">Behaviour Class Reference</div>  </div>
</div><!--header-->
<div class="contents">

<p>Parent class for all other behaviours.  
 <a href="class_behaviour.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="_behaviours_8h_source.html">Behaviours.h</a>&gt;</code></p>
<div class="dynheader">
Inheritance diagram for Behaviour:</div>
<div class="dyncontent">
 <div class="center">
  <img src="class_behaviour.png" usemap="#Behaviour_map" alt=""/>
  <map id="Behaviour_map" name="Behaviour_map">
<area href="class_breathe_l_e_ds.html" title="Behaviour that cycles all LEDs from full to minimum brightness and back at a speed specified as its a..." alt="BreatheLEDs" shape="rect" coords="153,56,296,80"/>
<area href="class_button_clicked.html" title="Behaviour that publishes a &quot;ButtonClicked&quot; message to the block&#39;s announcment topic of the MQQT broke..." alt="ButtonClicked" shape="rect" coords="153,112,296,136"/>
<area href="class_button_held.html" title="Behaviour that publishes a &quot;ButtonHeld&quot; message to the block&#39;s announcment topic of the MQQT broker." alt="ButtonHeld" shape="rect" coords="153,168,296,192"/>
<area href="class_button_pressed.html" title="Behaviour that publishes a &quot;ButtonPressed&quot; message to the block&#39;s announcment topic of the MQQT broke..." alt="ButtonPressed" shape="rect" coords="153,224,296,248"/>
<area href="class_button_released.html" title="Behaviour that publishes a &quot;ButtonReleased&quot; message to the block&#39;s announcment topic of the MQQT brok..." alt="ButtonReleased" shape="rect" coords="153,280,296,304"/>
<area href="class_button_tick.html" title="Behaviour that publishes a &quot;ButtonTick&quot; message to the block&#39;s announcment topic of the MQQT broker." alt="ButtonTick" shape="rect" coords="153,336,296,360"/>
<area href="class_light_all_l_e_ds.html" title="Behaviour that lights up all the LEDs to a brightness specified as its argument." alt="LightAllLEDs" shape="rect" coords="153,392,296,416"/>
<area href="class_light_some_l_e_ds.html" title="Behaviour that lights up a number of LEDs specified as its argument." alt="LightSomeLEDs" shape="rect" coords="153,448,296,472"/>
<area href="class_link.html" title="Experimental Behaviour leverages the ability to deliver commands over serial. If a block is connected..." alt="Link" shape="rect" coords="153,504,296,528"/>
<area href="class_ping_server.html" title="Experimental Behaviour that will regularly send a short message to the server so that the server know..." alt="PingServer" shape="rect" coords="153,560,296,584"/>
<area href="class_potentiometer_updated.html" title="Behaviour that publishes a &quot;PotentiometerUpdated&quot; message to the block&#39;s announcment topic of the MQQ..." alt="PotentiometerUpdated" shape="rect" coords="153,616,296,640"/>
<area href="class_rotary_encoder_updated.html" title="Behaviour that publishes a &quot;RotaryEncoderUpdated&quot; message to the block&#39;s announcment topic of the MQQ..." alt="RotaryEncoderUpdated" shape="rect" coords="153,672,296,696"/>
<area href="class_send_capabilities.html" title="Behaviour that publishes a series of messages listing all the the block&#39;s abilities to the block&#39;s an..." alt="SendCapabilities" shape="rect" coords="153,728,296,752"/>
<area href="class_servo_go_and_return.html" title="Behaviour that sets a servo to an angle before returning its position back to zero,..." alt="ServoGoAndReturn" shape="rect" coords="153,784,296,808"/>
<area href="class_servo_go_to.html" title="Behaviour that sets a servo to an angle specified as its argument." alt="ServoGoTo" shape="rect" coords="153,840,296,864"/>
<area href="class_servo_wiggle.html" title="Behaviour that wiggles a servo with the sweep angle specified as its argument." alt="ServoWiggle" shape="rect" coords="153,896,296,920"/>
  </map>
</div></div>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:ad5aa6388bf5b47911ae801ebbf82e35d"><td class="memItemLeft" align="right" valign="top">virtual char *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_behaviour.html#ad5aa6388bf5b47911ae801ebbf82e35d">args</a> ()</td></tr>
<tr class="separator:ad5aa6388bf5b47911ae801ebbf82e35d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aa09d1af17d15fa0c204f2b713e46fba0"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_behaviour.html#aa09d1af17d15fa0c204f2b713e46fba0">Behaviour</a> (String <a class="el" href="class_behaviour.html#a766009be6f0ed1acd74d4ba5c138a7bd">name</a>)</td></tr>
<tr class="separator:aa09d1af17d15fa0c204f2b713e46fba0"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a0f976beeea75cc999f4ce5cbdc889d54"><td class="memItemLeft" align="right" valign="top">virtual boolean&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_behaviour.html#a0f976beeea75cc999f4ce5cbdc889d54">is_background</a> ()</td></tr>
<tr class="separator:a0f976beeea75cc999f4ce5cbdc889d54"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a6194e394bab5d264e333b6962173064d"><td class="memItemLeft" align="right" valign="top">virtual boolean&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_behaviour.html#a6194e394bab5d264e333b6962173064d">is_interruptable</a> ()</td></tr>
<tr class="separator:a6194e394bab5d264e333b6962173064d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a2c47f0e25b4084939bd5cb5f78012385"><td class="memItemLeft" align="right" valign="top">virtual boolean&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_behaviour.html#a2c47f0e25b4084939bd5cb5f78012385">is_priority</a> ()</td></tr>
<tr class="separator:a2c47f0e25b4084939bd5cb5f78012385"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a629c91d3771c7938b22ff393b95518ef"><td class="memItemLeft" align="right" valign="top">virtual boolean&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_behaviour.html#a629c91d3771c7938b22ff393b95518ef">is_running</a> ()</td></tr>
<tr class="separator:a629c91d3771c7938b22ff393b95518ef"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a0d07ba942e21d9d368c5e3837de068b3"><td class="memItemLeft" align="right" valign="top">virtual boolean&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_behaviour.html#a0d07ba942e21d9d368c5e3837de068b3">is_temp</a> ()</td></tr>
<tr class="separator:a0d07ba942e21d9d368c5e3837de068b3"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a766009be6f0ed1acd74d4ba5c138a7bd"><td class="memItemLeft" align="right" valign="top">virtual String&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_behaviour.html#a766009be6f0ed1acd74d4ba5c138a7bd">name</a> ()</td></tr>
<tr class="separator:a766009be6f0ed1acd74d4ba5c138a7bd"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ab4bc4b2d9d9ec727fd84796c6c6d44b3"><td class="memItemLeft" align="right" valign="top">virtual String&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_behaviour.html#ab4bc4b2d9d9ec727fd84796c6c6d44b3">start</a> (String <a class="el" href="class_behaviour.html#ad5aa6388bf5b47911ae801ebbf82e35d">args</a>)</td></tr>
<tr class="separator:ab4bc4b2d9d9ec727fd84796c6c6d44b3"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a56f7e55bee64010414c07deb79426a9b"><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_behaviour.html#a56f7e55bee64010414c07deb79426a9b">stop</a> ()</td></tr>
<tr class="separator:a56f7e55bee64010414c07deb79426a9b"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a4b8190a1a262ab969fd7706cc55906c6"><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_behaviour.html#a4b8190a1a262ab969fd7706cc55906c6">update</a> ()</td></tr>
<tr class="separator:a4b8190a1a262ab969fd7706cc55906c6"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ab9099279876aa70410ab96ca589531df"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_behaviour.html#ab9099279876aa70410ab96ca589531df">~Behaviour</a> ()</td></tr>
<tr class="separator:ab9099279876aa70410ab96ca589531df"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pro-attribs"></a>
Protected Attributes</h2></td></tr>
<tr class="memitem:a93c2dc62b373e7d4b58c7cebded12f16"><td class="memItemLeft" align="right" valign="top">boolean&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_behaviour.html#a93c2dc62b373e7d4b58c7cebded12f16">_background</a> = false</td></tr>
<tr class="separator:a93c2dc62b373e7d4b58c7cebded12f16"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ab26c8020df403d81ff28d13e22b61c81"><td class="memItemLeft" align="right" valign="top">boolean&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_behaviour.html#ab26c8020df403d81ff28d13e22b61c81">_interruptable</a> = true</td></tr>
<tr class="separator:ab26c8020df403d81ff28d13e22b61c81"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ad6628fb93079b0f8e2ef4412a9046416"><td class="memItemLeft" align="right" valign="top">String&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_behaviour.html#ad6628fb93079b0f8e2ef4412a9046416">_name</a> = &quot;name&quot;</td></tr>
<tr class="separator:ad6628fb93079b0f8e2ef4412a9046416"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:af1f8d319677a6935c28acbbea643c46c"><td class="memItemLeft" align="right" valign="top">boolean&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_behaviour.html#af1f8d319677a6935c28acbbea643c46c">_priority</a> = false</td></tr>
<tr class="separator:af1f8d319677a6935c28acbbea643c46c"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a4397ea529500c0c3259777ffa4a6bad2"><td class="memItemLeft" align="right" valign="top">boolean&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_behaviour.html#a4397ea529500c0c3259777ffa4a6bad2">_running</a> = false</td></tr>
<tr class="separator:a4397ea529500c0c3259777ffa4a6bad2"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:acbe345ebc552c4f6875ec845d2697f9f"><td class="memItemLeft" align="right" valign="top">boolean&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_behaviour.html#acbe345ebc552c4f6875ec845d2697f9f">_temp</a> = false</td></tr>
<tr class="separator:acbe345ebc552c4f6875ec845d2697f9f"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p>Parent class for all other behaviours. </p>
<p>This class contains is a template for building block behaviours that can do just about anything you could dream up. It has a bunch of virtual methods that you can override in its children. </p>
</div><h2 class="groupheader">Constructor &amp; Destructor Documentation</h2>
<a id="aa09d1af17d15fa0c204f2b713e46fba0"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aa09d1af17d15fa0c204f2b713e46fba0">&#9670;&nbsp;</a></span>Behaviour()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">Behaviour::Behaviour </td>
          <td>(</td>
          <td class="paramtype">String&#160;</td>
          <td class="paramname"><em>name</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

</div>
</div>
<a id="ab9099279876aa70410ab96ca589531df"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ab9099279876aa70410ab96ca589531df">&#9670;&nbsp;</a></span>~Behaviour()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">Behaviour::~Behaviour </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

</div>
</div>
<h2 class="groupheader">Member Function Documentation</h2>
<a id="ad5aa6388bf5b47911ae801ebbf82e35d"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ad5aa6388bf5b47911ae801ebbf82e35d">&#9670;&nbsp;</a></span>args()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual char* Behaviour::args </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p>What arguments does the behaviour take? Override this to document your behaviour. </p>

<p>Reimplemented in <a class="el" href="class_servo_go_and_return.html#afc4fdd44cae56c9e239391fc819f5740">ServoGoAndReturn</a>, <a class="el" href="class_servo_wiggle.html#a10764f7adcfede311818328e042b65a1">ServoWiggle</a>, <a class="el" href="class_servo_go_to.html#a13ec355b036a947e216f32db3d876135">ServoGoTo</a>, <a class="el" href="class_rotary_encoder_updated.html#aaff2f2c49fe72414c71c1cbb631958e0">RotaryEncoderUpdated</a>, <a class="el" href="class_potentiometer_updated.html#aa26c8882cb48d9122f24a14f532a0c5b">PotentiometerUpdated</a>, <a class="el" href="class_breathe_l_e_ds.html#aecd600f1c7b2bcaf25a08099b18eaad1">BreatheLEDs</a>, <a class="el" href="class_light_all_l_e_ds.html#a8fcab516a3136401613e131507b0203e">LightAllLEDs</a>, <a class="el" href="class_light_some_l_e_ds.html#a1160de6497768ba1b20a3a7a29e0bb70">LightSomeLEDs</a>, <a class="el" href="class_link.html#a6d9f3f3139b5325cefe19af730d9bc54">Link</a>, <a class="el" href="class_button_tick.html#a0b9b56685acb47c96245af0d26206ba5">ButtonTick</a>, <a class="el" href="class_button_held.html#af60b3ecca59adfb0426e9baa146b3d7e">ButtonHeld</a>, <a class="el" href="class_button_clicked.html#afad90972997311c478dc50f25751160d">ButtonClicked</a>, <a class="el" href="class_button_released.html#adf6e9a6d53fae411656d8059d87e8daf">ButtonReleased</a>, and <a class="el" href="class_button_pressed.html#aa157f2034d16625c5322a7846e61af85">ButtonPressed</a>.</p>

</div>
</div>
<a id="a0f976beeea75cc999f4ce5cbdc889d54"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a0f976beeea75cc999f4ce5cbdc889d54">&#9670;&nbsp;</a></span>is_background()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual boolean Behaviour::is_background </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p>Can the behaviour run in the background? </p>

</div>
</div>
<a id="a6194e394bab5d264e333b6962173064d"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a6194e394bab5d264e333b6962173064d">&#9670;&nbsp;</a></span>is_interruptable()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual boolean Behaviour::is_interruptable </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p>Can this behaviour be interruped? </p>

</div>
</div>
<a id="a2c47f0e25b4084939bd5cb5f78012385"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a2c47f0e25b4084939bd5cb5f78012385">&#9670;&nbsp;</a></span>is_priority()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual boolean Behaviour::is_priority </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p>Should this behaviour override others? </p>

</div>
</div>
<a id="a629c91d3771c7938b22ff393b95518ef"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a629c91d3771c7938b22ff393b95518ef">&#9670;&nbsp;</a></span>is_running()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual boolean Behaviour::is_running </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p>Is the behaviour running? </p>

</div>
</div>
<a id="a0d07ba942e21d9d368c5e3837de068b3"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a0d07ba942e21d9d368c5e3837de068b3">&#9670;&nbsp;</a></span>is_temp()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual boolean Behaviour::is_temp </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p>Can this behaviour be run quickly without stopping what's going on (e.g. comms, debug)? </p>

</div>
</div>
<a id="a766009be6f0ed1acd74d4ba5c138a7bd"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a766009be6f0ed1acd74d4ba5c138a7bd">&#9670;&nbsp;</a></span>name()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual String Behaviour::name </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p>What's the name of this behaviour? </p>

</div>
</div>
<a id="ab4bc4b2d9d9ec727fd84796c6c6d44b3"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ab4bc4b2d9d9ec727fd84796c6c6d44b3">&#9670;&nbsp;</a></span>start()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual String Behaviour::start </td>
          <td>(</td>
          <td class="paramtype">String&#160;</td>
          <td class="paramname"><em>args</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p>Start the behaviour, with arguments. </p>

<p>Reimplemented in <a class="el" href="class_servo_go_and_return.html#a04dcc4eb914a339003b5d04927a83695">ServoGoAndReturn</a>, <a class="el" href="class_servo_wiggle.html#aad37514650c225f3307c8a93a1036995">ServoWiggle</a>, <a class="el" href="class_servo_go_to.html#a2947d36917cfa921fa20f6154e0f9fbb">ServoGoTo</a>, <a class="el" href="class_rotary_encoder_updated.html#ae8a2605c86703bcbec627a420cfdb1f4">RotaryEncoderUpdated</a>, <a class="el" href="class_potentiometer_updated.html#aea4c6c96cf2fb770677fafef821a844f">PotentiometerUpdated</a>, <a class="el" href="class_breathe_l_e_ds.html#a81bb278dcb88bf89c3886ec6a3749de7">BreatheLEDs</a>, <a class="el" href="class_light_all_l_e_ds.html#ad2e6d7b6230f58356065c767df62ea7f">LightAllLEDs</a>, <a class="el" href="class_light_some_l_e_ds.html#a25206d0ecbfc9d5cdb2cc19fde72a79e">LightSomeLEDs</a>, <a class="el" href="class_ping_server.html#ae334bb0601762caaf90f9ff2d8f0f1d5">PingServer</a>, <a class="el" href="class_link.html#a758369a0b6dd6e9460a7883b83d8969f">Link</a>, <a class="el" href="class_send_capabilities.html#a22f6f8ae27ebd478376f619629832ab5">SendCapabilities</a>, <a class="el" href="class_button_tick.html#a2315e24cbbfff47c9aae35529a766f76">ButtonTick</a>, <a class="el" href="class_button_held.html#a2ebd89985ab996459adc2c97b9f462a8">ButtonHeld</a>, <a class="el" href="class_button_clicked.html#a5079ef38b22d78e72e66a13b5d8936a8">ButtonClicked</a>, <a class="el" href="class_button_released.html#ad555a0e31d0b286dd75545f7759307fc">ButtonReleased</a>, and <a class="el" href="class_button_pressed.html#ae6bd011c8b9801ed372b957a82d5256f">ButtonPressed</a>.</p>

</div>
</div>
<a id="a56f7e55bee64010414c07deb79426a9b"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a56f7e55bee64010414c07deb79426a9b">&#9670;&nbsp;</a></span>stop()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual void Behaviour::stop </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p>Stop the behaviour. This can be useful to stop the behaviour after it has updated a set number of times, or after a fixed amount of time. </p>

</div>
</div>
<a id="a4b8190a1a262ab969fd7706cc55906c6"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a4b8190a1a262ab969fd7706cc55906c6">&#9670;&nbsp;</a></span>update()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual void Behaviour::update </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p>Update the behaviour periodically. </p>

<p>Reimplemented in <a class="el" href="class_servo_go_and_return.html#a24a373d01dad0729b75ffab97f673202">ServoGoAndReturn</a>, <a class="el" href="class_servo_wiggle.html#ad4c8bf0c71ab975aaac98ad9b879094a">ServoWiggle</a>, <a class="el" href="class_breathe_l_e_ds.html#aa73b6336ef075436fa01b7ffc999f939">BreatheLEDs</a>, <a class="el" href="class_ping_server.html#a40f0194de38762c74f405919283b2155">PingServer</a>, and <a class="el" href="class_link.html#a4212a26ee2583b08e2307e7385b9a548">Link</a>.</p>

</div>
</div>
<h2 class="groupheader">Member Data Documentation</h2>
<a id="a93c2dc62b373e7d4b58c7cebded12f16"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a93c2dc62b373e7d4b58c7cebded12f16">&#9670;&nbsp;</a></span>_background</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">boolean Behaviour::_background = false</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">protected</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

</div>
</div>
<a id="ab26c8020df403d81ff28d13e22b61c81"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ab26c8020df403d81ff28d13e22b61c81">&#9670;&nbsp;</a></span>_interruptable</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">boolean Behaviour::_interruptable = true</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">protected</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

</div>
</div>
<a id="ad6628fb93079b0f8e2ef4412a9046416"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ad6628fb93079b0f8e2ef4412a9046416">&#9670;&nbsp;</a></span>_name</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">String Behaviour::_name = &quot;name&quot;</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">protected</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

</div>
</div>
<a id="af1f8d319677a6935c28acbbea643c46c"></a>
<h2 class="memtitle"><span class="permalink"><a href="#af1f8d319677a6935c28acbbea643c46c">&#9670;&nbsp;</a></span>_priority</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">boolean Behaviour::_priority = false</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">protected</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

</div>
</div>
<a id="a4397ea529500c0c3259777ffa4a6bad2"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a4397ea529500c0c3259777ffa4a6bad2">&#9670;&nbsp;</a></span>_running</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">boolean Behaviour::_running = false</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">protected</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

</div>
</div>
<a id="acbe345ebc552c4f6875ec845d2697f9f"></a>
<h2 class="memtitle"><span class="permalink"><a href="#acbe345ebc552c4f6875ec845d2697f9f">&#9670;&nbsp;</a></span>_temp</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">boolean Behaviour::_temp = false</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">protected</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

</div>
</div>
<hr/>The documentation for this class was generated from the following file:<ul>
<li>src/<a class="el" href="_behaviours_8h_source.html">Behaviours.h</a></li>
</ul>
</div><!-- contents -->
<!-- HTML footer for doxygen 1.8.18-->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.9.1
</small></address>
</body>
</html>
